diff -ruN vdr-1.7.21/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_remote.h vdr-1.7.22/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_remote.h
--- vdr-1.7.21/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_remote.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.22/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_remote.h	2011-10-16 17:12:49.000000000 +0200
@@ -0,0 +1,39 @@
+/**********************************************************************
+ *
+ * HDFF firmware command interface library
+ *
+ * Copyright (C) 2011  Andreas Regel
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the
+ * Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *********************************************************************/
+
+#ifndef HDFFCMD_REMOTE_H
+#define HDFFCMD_REMOTE_H
+
+typedef enum HdffRemoteProtocol_t
+{
+    HDFF_REMOTE_PROTOCOL_NONE,
+    HDFF_REMOTE_PROTOCOL_RC5,
+    HDFF_REMOTE_PROTOCOL_RC6
+} HdffRemoteProtocol_t;
+
+
+int HdffCmdRemoteSetProtocol(int OsdDevice, HdffRemoteProtocol_t Protocol);
+
+int HdffCmdRemoteSetAddressFilter(int OsdDevice, int Enable, uint32_t Address);
+
+#endif /* HDFFCMD_REMOTE_H */
diff -ruN vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.c vdr-1.7.22/PLUGINS/src/dvbhddevice/setup.c
--- vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.c	2011-08-27 11:35:35.000000000 +0200
+++ vdr-1.7.22/PLUGINS/src/dvbhddevice/setup.c	2011-12-04 16:31:58.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.c 1.13 2011/08/27 09:35:35 kls Exp $
+ * $Id: setup.c 1.14 2011/12/04 15:31:58 kls Exp $
  */
 
 #include "setup.h"
@@ -20,12 +20,12 @@
 cHdffSetup::cHdffSetup(void)
 {
     Resolution = kResolution1080i;
-    VideoModeAdaption = HDFF::videoModeAdaptOff;
-    TvFormat = HDFF::tvFormat16by9;
-    VideoConversion = HDFF::videoConversionPillarbox;
-    AnalogueVideo = HDFF::videoOutCvbsYuv;
+    VideoModeAdaption = HDFF_VIDEO_MODE_ADAPT_OFF;
+    TvFormat = HDFF_TV_FORMAT_16_BY_9;
+    VideoConversion = HDFF_VIDEO_CONVERSION_PILLARBOX;
+    AnalogueVideo = HDFF_VIDEO_OUT_CVBS_YUV;
     AudioDelay = 0;
-    AudioDownmix = HDFF::downmixAutomatic;
+    AudioDownmix = HDFF_AUDIO_DOWNMIX_AUTOMATIC;
     OsdSize = 0;
     CecEnabled = 1;
     RemoteProtocol = 1;
@@ -68,7 +68,7 @@
             Width = 720;
             Height = 576;
         }
-        if (TvFormat == HDFF::tvFormat16by9)
+        if (TvFormat == HDFF_TV_FORMAT_16_BY_9)
             PixelAspect = 16.0 / 9.0;
         else
             PixelAspect = 4.0 / 3.0;
@@ -96,19 +96,19 @@
     PixelAspect /= double(Width) / Height;
 }
 
-HDFF::eHdmiVideoMode cHdffSetup::GetVideoMode(void)
+HdffVideoMode_t cHdffSetup::GetVideoMode(void)
 {
     switch (Resolution)
     {
         case kResolution1080i:
         default:
-            return HDFF::videoMode1080i50;
+            return HDFF_VIDEO_MODE_1080I50;
         case kResolution720p:
-            return HDFF::videoMode720p50;
+            return HDFF_VIDEO_MODE_720P50;
         case kResolution576p:
-            return HDFF::videoMode576p50;
+            return HDFF_VIDEO_MODE_576P50;
         case kResolution576i:
-            return HDFF::videoMode576i50;
+            return HDFF_VIDEO_MODE_576I50;
     }
 }
 
@@ -233,27 +233,27 @@
         {
             mHdffCmdIf->CmdHdmiSetVideoMode(mNewHdffSetup.GetVideoMode());
         }
-        HDFF::tVideoFormat videoFormat;
-        HDFF::tHdmiConfig hdmiConfig;
+        HdffVideoFormat_t videoFormat;
+        HdffHdmiConfig_t hdmiConfig;
 
         videoFormat.AutomaticEnabled = true;
         videoFormat.AfdEnabled = true;
-        videoFormat.TvFormat = (HDFF::eTvFormat) mNewHdffSetup.TvFormat;
-        videoFormat.VideoConversion = (HDFF::eVideoConversion) mNewHdffSetup.VideoConversion;
+        videoFormat.TvFormat = (HdffTvFormat_t) mNewHdffSetup.TvFormat;
+        videoFormat.VideoConversion = (HdffVideoConversion_t) mNewHdffSetup.VideoConversion;
         mHdffCmdIf->CmdAvSetVideoFormat(0, &videoFormat);
 
         mHdffCmdIf->CmdAvSetAudioDelay(mNewHdffSetup.AudioDelay);
-        mHdffCmdIf->CmdAvSetAudioDownmix((HDFF::eDownmixMode) mNewHdffSetup.AudioDownmix);
+        mHdffCmdIf->CmdAvSetAudioDownmix((HdffAudioDownmixMode_t) mNewHdffSetup.AudioDownmix);
 
-        mHdffCmdIf->CmdMuxSetVideoOut((HDFF::eVideoOut) mNewHdffSetup.AnalogueVideo);
+        mHdffCmdIf->CmdMuxSetVideoOut((HdffVideoOut_t) mNewHdffSetup.AnalogueVideo);
 
         hdmiConfig.TransmitAudio = true;
         hdmiConfig.ForceDviMode = false;
         hdmiConfig.CecEnabled = mNewHdffSetup.CecEnabled;
-        hdmiConfig.VideoModeAdaption = (HDFF::eVideoModeAdaption) mNewHdffSetup.VideoModeAdaption;
+        hdmiConfig.VideoModeAdaption = (HdffVideoModeAdaption_t) mNewHdffSetup.VideoModeAdaption;
         mHdffCmdIf->CmdHdmiConfigure(&hdmiConfig);
 
-        mHdffCmdIf->CmdRemoteSetProtocol((HDFF::eRemoteProtocol) mNewHdffSetup.RemoteProtocol);
+        mHdffCmdIf->CmdRemoteSetProtocol((HdffRemoteProtocol_t) mNewHdffSetup.RemoteProtocol);
         mHdffCmdIf->CmdRemoteSetAddressFilter(mNewHdffSetup.RemoteAddress >= 0, mNewHdffSetup.RemoteAddress);
     }
 
diff -ruN vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.h vdr-1.7.22/PLUGINS/src/dvbhddevice/setup.h
--- vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.h	2011-08-27 11:36:02.000000000 +0200
+++ vdr-1.7.22/PLUGINS/src/dvbhddevice/setup.h	2011-12-04 16:32:13.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.h 1.9 2011/08/27 09:36:02 kls Exp $
+ * $Id: setup.h 1.10 2011/12/04 15:32:13 kls Exp $
  */
 
 #ifndef _HDFF_SETUP_H_
@@ -17,7 +17,7 @@
     cHdffSetup(void);
     bool SetupParse(const char * Name, const char * Value);
     void GetOsdSize(int &Width, int &Height, double &PixelAspect);
-    HDFF::eHdmiVideoMode GetVideoMode(void);
+    HdffVideoMode_t GetVideoMode(void);
 
     int Resolution;
     int VideoModeAdaption;
diff -ruN vdr-1.7.21/PLUGINS/src/pictures/HISTORY vdr-1.7.22/PLUGINS/src/pictures/HISTORY
--- vdr-1.7.21/PLUGINS/src/pictures/HISTORY	2011-08-14 15:46:39.000000000 +0200
+++ vdr-1.7.22/PLUGINS/src/pictures/HISTORY	2011-11-02 21:58:22.000000000 +0100
@@ -55,3 +55,7 @@
 - The pic2mpg script now generates HD images (thanks to Andre Weidemann for his
   support in using convert/ffmpeg). The old SD version is still available as
   pic2mpg-sd.
+
+2011-11-02:
+
+- Fixed handling images that are rotated by 180 degrees in pic2mpg.
diff -ruN vdr-1.7.21/PLUGINS/src/pictures/pic2mpg vdr-1.7.22/PLUGINS/src/pictures/pic2mpg
--- vdr-1.7.21/PLUGINS/src/pictures/pic2mpg	2011-08-14 15:34:15.000000000 +0200
+++ vdr-1.7.22/PLUGINS/src/pictures/pic2mpg	2011-11-02 18:20:37.000000000 +0100
@@ -7,7 +7,7 @@
 #
 # See the README file for copyright information and how to reach the author.
 #
-# $Id: pic2mpg 2.2 2011/08/14 13:34:15 kls Exp $
+# $Id: pic2mpg 2.3 2011/11/02 17:20:37 kls Exp $
 
 use File::Path;
 use File::Spec;
@@ -124,7 +124,7 @@
   return if (!defined $PICTYPES{$Type});
   my $Exif = ImageInfo($Pict);
   my $Orientation = $$Exif{"Orientation"};
-  my ($Degrees) = $Orientation =~ /Rotate ([0-9]+) /; 
+  my ($Degrees) = $Orientation =~ /Rotate ([0-9]+)/; 
   my $Rotate = $Degrees ? "-rotate $Degrees" : "";
   print "orientation = '$Orientation' -> rotation = $Rotate\n" if ($Detailed);
   $Pict = EscapeMeta($Pict);
diff -ruN vdr-1.7.21/ci.h vdr-1.7.22/ci.h
--- vdr-1.7.21/ci.h	2007-01-03 13:49:10.000000000 +0100
+++ vdr-1.7.22/ci.h	2011-12-04 14:38:17.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.h 2.0 2007/01/03 12:49:10 kls Exp $
+ * $Id: ci.h 2.1 2011/12/04 13:38:17 kls Exp $
  */
 
 #ifndef __CI_H
@@ -220,7 +220,7 @@
        ///< CAM is currently not decrypting anything. If there is already a
        ///< channel being decrypted, a call to CanDecrypt() checks whether the
        ///< CAM can also decrypt the given channel. Only CAMs that have replied
-       ///< to the inital QUERY will perform this check at all. CAMs that never
+       ///< to the initial QUERY will perform this check at all. CAMs that never
        ///< replied to the initial QUERY are assumed not to be able to handle
        ///< more than one channel at a time.
   void StartDecrypting(void);
diff -ruN vdr-1.7.21/config.c vdr-1.7.22/config.c
--- vdr-1.7.21/config.c	2011-08-20 11:12:05.000000000 +0200
+++ vdr-1.7.22/config.c	2011-12-03 16:21:30.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 2.15 2011/08/20 09:12:05 kls Exp $
+ * $Id: config.c 2.16 2011/12/03 15:21:30 kls Exp $
  */
 
 #include "config.h"
@@ -63,6 +63,69 @@
   return (Address & mask) == (addr.s_addr & mask);
 }
 
+// --- cSatCableNumbers ------------------------------------------------------
+
+cSatCableNumbers::cSatCableNumbers(int Size, const char *s)
+{
+  size = Size;
+  array = MALLOC(int, size);
+  memset(array, size * sizeof(int), 0);
+  FromString(s);
+}
+
+cSatCableNumbers::~cSatCableNumbers()
+{
+  free(array);
+}
+
+bool cSatCableNumbers::FromString(const char *s)
+{
+  char *t;
+  int i = 0;
+  const char *p = s;
+  while (p && *p) {
+        int n = strtol(p, &t, 10);
+        if (t != p) {
+           if (i < size)
+              array[i++] = n;
+           else {
+              esyslog("ERROR: too many sat cable numbers in '%s'", s);
+              return false;
+              }
+           }
+        else {
+           esyslog("ERROR: invalid sat cable number in '%s'", s);
+           return false;
+           }
+        p = skipspace(t);
+        }
+  for ( ; i < size; i++)
+      array[i] = 0;
+  return true;
+}
+
+cString cSatCableNumbers::ToString(void)
+{
+  cString s("");
+  for (int i = 0; i < size; i++) {
+      s = cString::sprintf("%s%d ", *s, array[i]);
+      }
+  return s;
+}
+
+int cSatCableNumbers::FirstDeviceIndex(int DeviceIndex) const
+{
+  if (0 <= DeviceIndex && DeviceIndex < size) {
+     if (int CableNr = array[DeviceIndex]) {
+        for (int i = 0; i < size; i++) {
+            if (i < DeviceIndex && array[i] == CableNr)
+               return i;
+            }
+        }
+     }
+  return -1;
+}
+
 // --- cNestedItem -----------------------------------------------------------
 
 cNestedItem::cNestedItem(const char *Text, bool WithSubItems)
@@ -396,6 +459,7 @@
   CurrentVolume = MAXVOLUME;
   CurrentDolby = 0;
   InitialChannel = "";
+  DeviceBondings = "";
   InitialVolume = -1;
   ChannelsWrap = 0;
   EmergencyExit = 1;
@@ -405,6 +469,7 @@
 {
   memcpy(&__BeginData__, &s.__BeginData__, (char *)&s.__EndData__ - (char *)&s.__BeginData__);
   InitialChannel = s.InitialChannel;
+  DeviceBondings = s.DeviceBondings;
   return *this;
 }
 
@@ -589,6 +654,7 @@
   else if (!strcasecmp(Name, "CurrentDolby"))        CurrentDolby       = atoi(Value);
   else if (!strcasecmp(Name, "InitialChannel"))      InitialChannel     = Value;
   else if (!strcasecmp(Name, "InitialVolume"))       InitialVolume      = atoi(Value);
+  else if (!strcasecmp(Name, "DeviceBondings"))      DeviceBondings     = Value;
   else if (!strcasecmp(Name, "ChannelsWrap"))        ChannelsWrap       = atoi(Value);
   else if (!strcasecmp(Name, "EmergencyExit"))       EmergencyExit      = atoi(Value);
   else
@@ -685,6 +751,7 @@
   Store("CurrentDolby",       CurrentDolby);
   Store("InitialChannel",     InitialChannel);
   Store("InitialVolume",      InitialVolume);
+  Store("DeviceBondings",     DeviceBondings);
   Store("ChannelsWrap",       ChannelsWrap);
   Store("EmergencyExit",      EmergencyExit);
 
diff -ruN vdr-1.7.21/config.h vdr-1.7.22/config.h
--- vdr-1.7.21/config.h	2011-08-20 10:51:47.000000000 +0200
+++ vdr-1.7.22/config.h	2011-12-03 15:19:52.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.34 2011/08/20 08:51:47 kls Exp $
+ * $Id: config.h 2.36 2011/12/03 14:19:52 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.21"
-#define VDRVERSNUM   10721  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.22"
+#define VDRVERSNUM   10722  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.21"
-#define APIVERSNUM   10721  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.22"
+#define APIVERSNUM   10722  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -61,6 +61,25 @@
   bool Accepts(in_addr_t Address);
   };
 
+class cSatCableNumbers {
+private:
+  int size;
+  int *array;
+public:
+  cSatCableNumbers(int Size, const char *s = NULL);
+  ~cSatCableNumbers();
+  int Size(void) const { return size; }
+  int *Array(void) { return array; }
+  bool FromString(const char *s);
+  cString ToString(void);
+  int FirstDeviceIndex(int DeviceIndex) const;
+      ///< Returns the first device index (starting at 0) that uses the same
+      ///< sat cable number as the device with the given DeviceIndex.
+      ///< If the given device does not use the same sat cable as any other device,
+      ///< or if the resulting value would be the same as DeviceIndex,
+      ///< or if DeviceIndex is out of range, -1 is returned.
+  };
+
 template<class T> class cConfig : public cList<T> {
 private:
   char *fileName;
@@ -292,6 +311,7 @@
   int EmergencyExit;
   int __EndData__;
   cString InitialChannel;
+  cString DeviceBondings;
   cSetup(void);
   cSetup& operator= (const cSetup &s);
   bool Load(const char *FileName);
diff -ruN vdr-1.7.21/cutter.c vdr-1.7.22/cutter.c
--- vdr-1.7.21/cutter.c	2011-08-21 13:08:08.000000000 +0200
+++ vdr-1.7.22/cutter.c	2011-12-04 13:55:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 2.8 2011/08/21 11:08:08 kls Exp $
+ * $Id: cutter.c 2.10 2011/12/04 12:55:53 kls Exp $
  */
 
 #include "cutter.h"
@@ -100,7 +100,8 @@
            if (fromIndex->Get(Index++, &FileNumber, &FileOffset, &Independent, &Length)) {
               if (FileNumber != CurrentFileNumber) {
                  fromFile = fromFileName->SetOffset(FileNumber, FileOffset);
-                 fromFile->SetReadAhead(MEGABYTE(20));
+                 if (fromFile)
+                    fromFile->SetReadAhead(MEGABYTE(20));
                  CurrentFileNumber = FileNumber;
                  }
               if (fromFile) {
@@ -210,7 +211,7 @@
      cRecording Recording(FileName);
 
      cMarks FromMarks;
-     FromMarks.Load(FileName);
+     FromMarks.Load(FileName, Recording.FramesPerSecond(), Recording.IsPesRecording());
      if (cMark *First = FromMarks.First())
         Recording.SetStartTime(Recording.Start() + (int(First->Position() / Recording.FramesPerSecond() + 30) / 60) * 60);
 
diff -ruN vdr-1.7.21/device.c vdr-1.7.22/device.c
--- vdr-1.7.21/device.c	2011-08-26 14:56:00.000000000 +0200
+++ vdr-1.7.22/device.c	2011-10-16 16:36:43.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.42 2011/08/26 12:56:00 kls Exp $
+ * $Id: device.c 2.44 2011/10/16 14:36:43 kls Exp $
  */
 
 #include "device.h"
@@ -95,6 +95,8 @@
   camSlot = NULL;
   startScrambleDetection = 0;
 
+  occupiedTimeout = 0;
+
   player = NULL;
   isPlayingVideo = false;
   ClrAvailableTracks();
@@ -638,14 +640,14 @@
   return NULL;
 }
 
-bool cDevice::IsTunedToTransponder(const cChannel *Channel)
+bool cDevice::IsTunedToTransponder(const cChannel *Channel) const
 {
   return false;
 }
 
-bool cDevice::MaySwitchTransponder(void)
+bool cDevice::MaySwitchTransponder(const cChannel *Channel) const
 {
-  return !Receiving(true) && !(pidHandles[ptAudio].pid || pidHandles[ptVideo].pid || pidHandles[ptDolby].pid);
+  return time(NULL) > occupiedTimeout && !Receiving(true) && !(pidHandles[ptAudio].pid || pidHandles[ptVideo].pid || pidHandles[ptDolby].pid);
 }
 
 bool cDevice::SwitchChannel(const cChannel *Channel, bool LiveView)
@@ -786,6 +788,18 @@
      }
 }
 
+int cDevice::Occupied(void) const
+{
+  int Seconds = occupiedTimeout - time(NULL);
+  return Seconds > 0 ? Seconds : 0;
+}
+
+void cDevice::SetOccupied(int Seconds)
+{
+  if (Seconds >= 0)
+     occupiedTimeout = time(NULL) + min(Seconds, MAXOCCUPIEDTIMEOUT);
+}
+
 bool cDevice::SetChannelDevice(const cChannel *Channel, bool LiveView)
 {
   return false;
@@ -1474,6 +1488,7 @@
 int cDevice::Priority(void) const
 {
   int priority = IsPrimaryDevice() ? Setup.PrimaryLimit - 1 : DEFAULTPRIORITY;
+  cMutexLock MutexLock(&mutexReceiver);
   for (int i = 0; i < MAXRECEIVERS; i++) {
       if (receiver[i])
          priority = max(receiver[i]->priority, priority);
@@ -1488,6 +1503,7 @@
 
 bool cDevice::Receiving(bool CheckAny) const
 {
+  cMutexLock MutexLock(&mutexReceiver);
   for (int i = 0; i < MAXRECEIVERS; i++) {
       if (receiver[i] && (CheckAny || receiver[i]->priority >= 0)) // cReceiver with priority < 0 doesn't count
          return true;
diff -ruN vdr-1.7.21/device.h vdr-1.7.22/device.h
--- vdr-1.7.21/device.h	2011-08-26 14:52:29.000000000 +0200
+++ vdr-1.7.22/device.h	2011-12-04 14:38:17.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.27 2011/08/26 12:52:29 kls Exp $
+ * $Id: device.h 2.30 2011/12/04 13:38:17 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -30,6 +30,7 @@
 #define MAXRECEIVERS       16 // the maximum number of receivers per device
 #define MAXVOLUME         255
 #define VOLUMEDELTA         5 // used to increase/decrease the volume
+#define MAXOCCUPIEDTIMEOUT 99 // max. time (in seconds) a device may be occupied
 
 enum eSetChannelResult { scrOk, scrNotAvailable, scrNoTransfer, scrFailed };
 
@@ -220,6 +221,8 @@
 
 // Channel facilities
 
+private:
+  time_t occupiedTimeout;
 protected:
   static int currentChannel;
 public:
@@ -272,12 +275,14 @@
          ///< This is not one of the channels in the global cChannels list, but rather
          ///< a local copy. The result may be NULL if the device is not tuned to any
          ///< transponder.
-  virtual bool IsTunedToTransponder(const cChannel *Channel);
+  virtual bool IsTunedToTransponder(const cChannel *Channel) const;
          ///< Returns true if this device is currently tuned to the given Channel's
          ///< transponder.
-  virtual bool MaySwitchTransponder(void);
-         ///< Returns true if it is ok to switch the transponder on this device,
-         ///< without disturbing any other activities.
+  virtual bool MaySwitchTransponder(const cChannel *Channel) const;
+         ///< Returns true if it is ok to switch to the Channel's transponder on this
+         ///< device, without disturbing any other activities. If an occupied timeout
+         ///< has been set for this device, and that timeout has not yet expired,
+         ///< this function returns false,
   bool SwitchChannel(const cChannel *Channel, bool LiveView);
          ///< Switches the device to the given Channel, initiating transfer mode
          ///< if necessary.
@@ -300,6 +305,16 @@
          ///< channel number while replaying.
   void ForceTransferMode(void);
          ///< Forces the device into transfermode for the current channel.
+  int Occupied(void) const;
+         ///< Returns the number of seconds this device is still occupied for.
+  void SetOccupied(int Seconds);
+         ///< Sets the occupied timeout for this device to the given number of
+         ///< Seconds, This can be used to tune a device to a particular transponder
+         ///< and make sure it will stay there for a certain amount of time, for
+         ///< instance to collect EPG data. This function shall only be called
+         ///< after the device has been successfully tuned to the requested transponder.
+         ///< Seconds will be silently limited to MAXOCCUPIEDTIMEOUT. Values less than
+         ///< 0 will be silently ignored.
   virtual bool HasLock(int TimeoutMs = 0);
          ///< Returns true if the device has a lock on the requested transponder.
          ///< Default is true, a specific device implementation may return false
@@ -457,7 +472,7 @@
        ///< Sets the current subtitle track to the given value.
 public:
   void ClrAvailableTracks(bool DescriptionsOnly = false, bool IdsOnly = false);
-       ///< Clears the list of currently availabe tracks. If DescriptionsOnly
+       ///< Clears the list of currently available tracks. If DescriptionsOnly
        ///< is true, only the track descriptions will be cleared. With IdsOnly
        ///< set to true only the ids will be cleared. IdsOnly is only taken
        ///< into account if DescriptionsOnly is false.
@@ -650,10 +665,10 @@
        ///< Returns true if the device itself or any of the file handles in
        ///< Poller is ready for further action.
        ///< If TimeoutMs is not zero, the device will wait up to the given number
-       ///< of milleseconds before returning in case it can't accept any data.
+       ///< of milliseconds before returning in case it can't accept any data.
   virtual bool Flush(int TimeoutMs = 0);
        ///< Returns true if the device's output buffers are empty, i. e. any
-       ///< data which was bufferd so far has been processed.
+       ///< data which was buffered so far has been processed.
        ///< If TimeoutMs is not zero, the device will wait up to the given
        ///< number of milliseconds before returning in case there is still
        ///< data in the buffers.
@@ -697,7 +712,7 @@
 // Receiver facilities
 
 private:
-  cMutex mutexReceiver;
+  mutable cMutex mutexReceiver;
   cReceiver *receiver[MAXRECEIVERS];
 public:
   int Priority(void) const;
@@ -726,7 +741,7 @@
        ///< Detaches the given receiver from this device.
   void DetachAll(int Pid);
        ///< Detaches all receivers from this device for this pid.
-  void DetachAllReceivers(void);
+  virtual void DetachAllReceivers(void);
        ///< Detaches all receivers from this device.
   };
 
diff -ruN vdr-1.7.21/diseqc.c vdr-1.7.22/diseqc.c
--- vdr-1.7.21/diseqc.c	2011-08-06 12:32:18.000000000 +0200
+++ vdr-1.7.22/diseqc.c	2011-09-17 16:13:31.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: diseqc.c 2.5 2011/08/06 10:32:18 kls Exp $
+ * $Id: diseqc.c 2.9 2011/09/17 14:13:31 kls Exp $
  */
 
 #include "diseqc.h"
@@ -12,6 +12,81 @@
 #include "sources.h"
 #include "thread.h"
 
+static bool ParseDeviceNumbers(const char *s, int &Devices)
+{
+  if (*s && s[strlen(s) - 1] == ':') {
+     const char *p = s;
+     while (*p && *p != ':') {
+           char *t = NULL;
+           int d = strtol(p, &t, 10);
+           p = t;
+           if (0 < d && d < 31)
+              Devices |= (1 << d - 1);
+           else {
+              esyslog("ERROR: invalid device number %d in '%s'", d, s);
+              return false;
+              }
+           }
+     }
+  return true;
+}
+
+// --- cScr ------------------------------------------------------------------
+
+cScr::cScr(void)
+{
+  devices = 0;
+  channel = -1;
+  userBand = 0;
+  pin = -1;
+  used = false;
+}
+
+bool cScr::Parse(const char *s)
+{
+  if (!ParseDeviceNumbers(s, devices))
+     return false;
+  if (devices)
+     return true;
+  bool result = false;
+  int fields = sscanf(s, "%d %u %d", &channel, &userBand, &pin);
+  if (fields == 2 || fields == 3) {
+     if (channel >= 0 && channel < 8) {
+        result = true;
+        if (fields == 3 && (pin < 0 || pin > 255)) {
+           esyslog("Error: invalid SCR pin '%d'", pin);
+           result = false;
+           }
+        }
+     else
+        esyslog("Error: invalid SCR channel '%d'", channel);
+     }
+  return result;
+}
+
+// --- cScrs -----------------------------------------------------------------
+
+cScrs Scrs;
+
+cScr *cScrs::GetUnused(int Device)
+{
+  cMutexLock MutexLock(&mutex);
+  int Devices = 0;
+  for (cScr *p = First(); p; p = Next(p)) {
+      if (p->Devices()) {
+         Devices = p->Devices();
+         continue;
+         }
+      if (Devices && !(Devices & (1 << Device - 1)))
+         continue;
+      if (!p->Used()) {
+        p->SetUsed(true);
+        return p;
+        }
+      }
+  return NULL;
+}
+
 // --- cDiseqc ---------------------------------------------------------------
 
 cDiseqc::cDiseqc(void)
@@ -21,9 +96,9 @@
   slof = 0;
   polarization = 0;
   lof = 0;
+  scrBank = -1;
   commands = NULL;
   parsing = false;
-  numCodes = 0;
 }
 
 cDiseqc::~cDiseqc()
@@ -33,23 +108,12 @@
 
 bool cDiseqc::Parse(const char *s)
 {
+  if (!ParseDeviceNumbers(s, devices))
+     return false;
+  if (devices)
+     return true;
   bool result = false;
   char *sourcebuf = NULL;
-  if (*s && s[strlen(s) - 1] == ':') {
-     const char *p = s;
-     while (*p && *p != ':') {
-           char *t = NULL;
-           int d = strtol(p, &t, 10);
-           p = t;
-           if (0 < d && d < 32)
-              devices |= (1 << d - 1);
-           else {
-              esyslog("ERROR: invalid device number %d in '%s'", d, s);
-              return false;
-              }
-           }
-     return true;
-     }
   int fields = sscanf(s, "%a[^ ] %d %c %d %a[^\n]", &sourcebuf, &slof, &polarization, &lof, &commands);
   if (fields == 4)
      commands = NULL; //XXX Apparently sscanf() doesn't work correctly if the last %a argument results in an empty string
@@ -60,7 +124,7 @@
         if (polarization == 'V' || polarization == 'H' || polarization == 'L' || polarization == 'R') {
            parsing = true;
            const char *CurrentAction = NULL;
-           while (Execute(&CurrentAction) != daNone)
+           while (Execute(&CurrentAction, NULL, NULL, NULL, NULL) != daNone)
                  ;
            parsing = false;
            result = !commands || !*CurrentAction;
@@ -75,6 +139,31 @@
   return result;
 }
 
+uint cDiseqc::SetScrFrequency(uint SatFrequency, const cScr *Scr, uint8_t *Codes) const
+{
+  uint t = SatFrequency == 0 ? 0 : (SatFrequency + Scr->UserBand() + 2) / 4 - 350; // '+ 2' together with '/ 4' results in rounding!
+  if (t < 1024 && Scr->Channel() >= 0 && Scr->Channel() < 8) {
+     Codes[3] = t >> 8 | (t == 0 ? 0 : scrBank << 2) | Scr->Channel() << 5;
+     Codes[4] = t;
+     if (t)
+        return (t + 350) * 4 - SatFrequency;
+     }
+  return 0;
+}
+
+int cDiseqc::SetScrPin(const cScr *Scr, uint8_t *Codes) const
+{
+  if (Scr->Pin() >= 0 && Scr->Pin() <= 255) {
+     Codes[2] = 0x5C;
+     Codes[5] = Scr->Pin();
+     return 6;
+     }
+  else {
+     Codes[2] = 0x5A;
+     return 5;
+     }
+}
+
 const char *cDiseqc::Wait(const char *s) const
 {
   char *p = NULL;
@@ -89,7 +178,25 @@
   return NULL;
 }
 
-const char *cDiseqc::Codes(const char *s) const
+const char *cDiseqc::GetScrBank(const char *s) const
+{
+  char *p = NULL;
+  errno = 0;
+  int n = strtol(s, &p, 10);
+  if (!errno && p != s && n >= 0 && n < 8) {
+     if (parsing) {
+        if (scrBank < 0)
+           scrBank = n;
+        else
+           esyslog("ERROR: more than one scr bank in '%s'", s - 1);
+        }
+     return p;
+     }
+  esyslog("ERROR: more than one scr bank in '%s'", s - 1);
+  return NULL;
+}
+
+const char *cDiseqc::GetCodes(const char *s, uchar *Codes, uint8_t *MaxCodes) const
 {
   const char *e = strchr(s, ']');
   if (e) {
@@ -101,9 +208,13 @@
               char *p;
               int n = strtol(t, &p, 16);
               if (!errno && p != t && 0 <= n && n <= 255) {
-                 if (!parsing) {
-                    codes[NumCodes++] = uchar(n);
-                    numCodes = NumCodes;
+                 if (Codes) {
+                    if (NumCodes < *MaxCodes)
+                       Codes[NumCodes++] = uchar(n);
+                    else {
+                       esyslog("ERROR: too many codes in code sequence '%s'", s - 1);
+                       return NULL;
+                       }
                     }
                  t = skipspace(p);
                  }
@@ -117,6 +228,8 @@
               return NULL;
               }
            }
+     if (MaxCodes)
+        *MaxCodes = NumCodes;
      return e + 1;
      }
   else
@@ -124,7 +237,7 @@
   return NULL;
 }
 
-cDiseqc::eDiseqcActions cDiseqc::Execute(const char **CurrentAction) const
+cDiseqc::eDiseqcActions cDiseqc::Execute(const char **CurrentAction, uchar *Codes, uint8_t *MaxCodes, const cScr *Scr, uint *Frequency) const
 {
   if (!*CurrentAction)
      *CurrentAction = commands;
@@ -138,7 +251,16 @@
           case 'A': return daMiniA;
           case 'B': return daMiniB;
           case 'W': *CurrentAction = Wait(*CurrentAction); break;
-          case '[': *CurrentAction = Codes(*CurrentAction); return *CurrentAction ? daCodes : daNone;
+          case 'S': *CurrentAction = GetScrBank(*CurrentAction); break;
+          case '[': *CurrentAction = GetCodes(*CurrentAction, Codes, MaxCodes);
+                    if (*CurrentAction) {
+                       if (Scr && Frequency) {
+                          *Frequency = SetScrFrequency(*Frequency, Scr, Codes);
+                          *MaxCodes = SetScrPin(Scr, Codes);
+                          }
+                       return daCodes;
+                       }
+                    break;
           default: return daNone;
           }
         }
@@ -149,7 +271,7 @@
 
 cDiseqcs Diseqcs;
 
-const cDiseqc *cDiseqcs::Get(int Device, int Source, int Frequency, char Polarization) const
+const cDiseqc *cDiseqcs::Get(int Device, int Source, int Frequency, char Polarization, const cScr **Scr) const
 {
   int Devices = 0;
   for (const cDiseqc *p = First(); p; p = Next(p)) {
@@ -159,8 +281,16 @@
          }
       if (Devices && !(Devices & (1 << Device - 1)))
          continue;
-      if (p->Source() == Source && p->Slof() > Frequency && p->Polarization() == toupper(Polarization))
+      if (p->Source() == Source && p->Slof() > Frequency && p->Polarization() == toupper(Polarization)) {
+         if (p->IsScr() && Scr && !*Scr) {
+            *Scr = Scrs.GetUnused(Device);
+            if (*Scr)
+               dsyslog("SCR %d assigned to device %d", (*Scr)->Channel(), Device);
+            else
+               esyslog("ERROR: no free SCR entry available for device %d", Device);
+            }
          return p;
+         }
       }
   return NULL;
 }
